-- Set leader {{{
vim.api.nvim_set_keymap('n', '<Space>', '<NOP>', { noremap = true, silent = true })
vim.g.mapleader = ' '
-- }}}
-- resize {{{
vim.api.nvim_set_keymap('n', '<c-up>', '<cmd>resize -2<cr>', { noremap = true, silent = true })
vim.api.nvim_set_keymap('n', '<c-down>', '<cmd>resize +2<cr>', { noremap = true, silent = true })
vim.api.nvim_set_keymap('n', '<c-left>', '<cmd>vertical resize -2<cr>', { noremap = true, silent = true })
vim.api.nvim_set_keymap('n', '<c-right>', '<cmd>vertical resize -2<cr>', { noremap = true, silent = true })
-- }}}
-- indent {{{
vim.api.nvim_set_keymap('v', '<', '<gv', { noremap = true, silent = true })
vim.api.nvim_set_keymap('v', '>', '>gv', { noremap = true, silent = true })
-- }}}
-- open/close folds with enter key {{{
vim.api.nvim_set_keymap('n', '<cr>', "@=(foldlevel('.')?'za':\"<Space>\")<CR>", { noremap = true, silent = true })
-- }}}
-- terminal {{{
vim.api.nvim_set_keymap('n', '<home>', '<cmd>ToggleTerm<cr>', { noremap = true, silent = true })
vim.api.nvim_set_keymap('t', '<home>', '<cmd>ToggleTerm<cr>', { noremap = true, silent = true })
vim.api.nvim_set_keymap('v', '<home>', '<cmd>ToggleTerm<cr>', { noremap = true, silent = true })
vim.api.nvim_set_keymap('i', '<home>', '<cmd>ToggleTerm<cr>', { noremap = true, silent = true })
-- }}}
-- misc {{{
vim.api.nvim_set_keymap('n', '<c-space>', '<cmd>nohlsearch<cr>', { noremap = true, silent = true })
vim.api.nvim_set_keymap('v', '<C-p>', '"_dp', { noremap = true, silent = true })
vim.api.nvim_set_keymap('x', 'E', ":move '<-2<cr>gv-gv", { noremap = true, silent = true })
vim.api.nvim_set_keymap('x', 'N', ":move '>+1<cr>gv-gv", { noremap = true, silent = true })
vim.api.nvim_set_keymap('n', '<c-\\>', 'z=1<cr><cr>', { noremap = true, silent = true })
-- vim.api.nvim_set_keymap(
-- 	'n',
-- 	'<leader>lf',
-- 	'<cmd>lua vim.lsp.buf.format { async = true }<cr>',
-- 	{ noremap = true, silent = true }
-- )

-- }}}
-- vim.api.nvim_set_keymap("n", "", "<cmd><cr>", { noremap = true, silent = true })

vim.api.nvim_set_keymap('n', '<BS>', ':', { noremap = true })
-- vim.api.nvim_set_keymap('n', ';', ':', { noremap = true })
vim.api.nvim_set_keymap('n', '<leader>rs', ':s///gI<Left><Left><Left><Left><Left><Left>', { noremap = true })
vim.api.nvim_set_keymap('n', '<leader>rr', ':%s///gI<Left><Left><Left><Left>', { noremap = true })
vim.api.nvim_set_keymap('v', '<leader>r', ':s///gI<Left><Left><Left><Left>', { noremap = true })

vim.api.nvim_set_keymap('n', '<leader>xl', '<cmd>TroubleToggle loclist<cr>', { silent = true, noremap = true })
vim.api.nvim_set_keymap('n', '<leader>xq', '<cmd>TroubleToggle quickfix<cr>', { silent = true, noremap = true })
vim.api.nvim_set_keymap('n', 'gR', '<cmd>TroubleToggle lsp_references<cr>', { silent = true, noremap = true })
vim.api.nvim_set_keymap('n', '<leader>xx', '<cmd>TroubleToggle<cr>', { silent = true, noremap = true })
vim.api.nvim_set_keymap(
	'n',
	'<leader>xw',
	'<cmd>TroubleToggle workspace_diagnostics<cr>',
	{ silent = true, noremap = true }
)
vim.api.nvim_set_keymap(
	'n',
	'<leader>xd',
	'<cmd>TroubleToggle document_diagnostics<cr>',
	{ silent = true, noremap = true }
)

function MapDHM()
	vim.api.nvim_set_keymap('n', 'i', 'l', { noremap = true })
	vim.api.nvim_set_keymap('n', 'n', 'j', { noremap = true })
	vim.api.nvim_set_keymap('n', 'e', 'k', { noremap = true })
	vim.api.nvim_set_keymap('v', 'i', 'l', { noremap = true })
	vim.api.nvim_set_keymap('v', 'n', 'j', { noremap = true })
	vim.api.nvim_set_keymap('v', 'e', 'k', { noremap = true })
	vim.api.nvim_set_keymap('n', 'l', 'i', { noremap = true })
	vim.api.nvim_set_keymap('n', 'N', 'J', { noremap = true })
	vim.api.nvim_set_keymap('n', 'j', 'n', { noremap = true })
	vim.api.nvim_set_keymap('n', 'J', 'N', { noremap = true })
	vim.api.nvim_set_keymap('n', '<nop>', 'I', { noremap = true })
end

function UnMapDHM()
	vim.api.nvim_del_keymap('n', 'l')
	vim.api.nvim_del_keymap('n', 'j')
	vim.api.nvim_del_keymap('v', 'l')
	vim.api.nvim_del_keymap('v', 'j')
	vim.api.nvim_del_keymap('v', 'k')
	vim.api.nvim_del_keymap('n', 'i')
	vim.api.nvim_del_keymap('n', 'J')
	vim.api.nvim_del_keymap('n', 'n')
	vim.api.nvim_del_keymap('n', 'N')
end

local handle = io.popen 'lsusb | grep -c Sofle'
local automap = handle:read '*n'
handle:close()

if automap or os.getenv("SSH_TTY") then
	MapDHM()
end
